﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Styx.Pathing;
using Styx.Pathing.FlightorNavigation;
using Styx.CommonBot;
using Styx.CommonBot.Frames;

public class LoveTokenPlugin : HBPlugin
{
    private const int VendorID = 37674;
    private const int LoveTokenID = 49927;
    private const int LovelyCharmID = 49655;
    private const int LovelyCharmBraceletID = 49916;

    private bool isStarted = false;
    private bool isBuying = false;
    private bool isCastingSend = false;

    public override string Author { get { return "Alex"; } }
    public override Version Version { get { return new Version(1, 0); } }
    public override string Name { get { return "Love Token Plugin"; } }

    public LocalPlayer Me { get { return StyxWoW.Me; } }

    public override void Initialize()
    {
        HotkeysManager.Unregister("lvPluginHk");
        HotkeysManager.Register("lvPluginHk", System.Windows.Forms.Keys.F3, ModifierKeys.Control, Go);
        Lua.Events.AttachEvent("BAG_UPDATE", ItemBought);
        Lua.Events.AttachEvent("UNIT_SPELLCAST_START", SpellCastStart);
        BotEvents.OnBotStop += BotStop;
        isStarted = false;
        isBuying = false;
        isCastingSend = false;
    }

    private void SpellCastStart(object sender, LuaEventArgs args)
    {
        isCastingSend = false;
    }

    private void ItemBought(object sender, LuaEventArgs args)
    {
        isBuying = false;
    }

    private void BotStop(EventArgs args)
    {
        BotStop();
    }

    private void Go(Hotkey obj)
    {
        if (isStarted)
        {
            BotStop();
        }
        else
        {
            BotStart();
        }
    }

    private void BotStart()
    {
        if (!TreeRoot.IsRunning)
        {
            Lua.DoString("print(\"Bot not started! Please start the bot.\")");
            isStarted = false;
        }
        else
        {
            isStarted = true;
            isBuying = false;
            isCastingSend = false;
        }
    }

    private void BotStop()
    {
        isStarted = false;
    }

    private void PluginLog(string message)
    {
        Logging.Write(LogLevel.Normal, "[LoveTokenPlugin]: " + message);
        Lua.DoString("print(\"" + message + "\")");
    }

    private bool IsVendorAround(int Entry)
    {
        var unit = ObjectManager.ObjectList.Where(
            t => t.Type == WoWObjectType.Unit &&
            t.ToUnit().IsAlive &&
            t.ToUnit().Entry == Entry &&
            t.ToUnit().WithinInteractRange
        ).FirstOrDefault();

        return unit != null;
    }

    private WoWUnit GetVendor(int Entry)
    {
        var unit = ObjectManager.ObjectList.Where(
            t => t.Type == WoWObjectType.Unit &&
            t.ToUnit().IsAlive &&
            t.ToUnit().Entry == Entry &&
            t.ToUnit().WithinInteractRange
        ).FirstOrDefault();

        return unit.ToUnit();
    }

    

    public override void Pulse()
    {
        if (!StyxWoW.IsInGame || !StyxWoW.IsInWorld || StyxWoW.Me.Combat || !StyxWoW.Me.IsAlive || StyxWoW.Me.IsCasting )
            return;

        if (!isStarted)
            return;

        if (!IsVendorAround(VendorID))
        {
            PluginLog("No vendor around. Stop.");
            BotStop();
            return;
        }

        var vendor = GetVendor(VendorID);

        if (Me.BagItems.Where(t => t.Entry == LovelyCharmBraceletID).FirstOrDefault() != null)
        {
            if (isBuying)
                return;

            if (MerchantFrame.Instance == null || !MerchantFrame.Instance.IsVisible)
            {
                vendor.Interact();
                return;
            }

            if (MerchantFrame.Instance != null && MerchantFrame.Instance.IsVisible)
            {
                isBuying = true;
                MerchantFrame.Instance.BuyItem(0, 1);
                return;
            }
        }

        if (MerchantFrame.Instance != null && MerchantFrame.Instance.IsVisible)
        {
            MerchantFrame.Instance.Close();
            return;
        }

        var items = Me.BagItems;
        foreach (var item in items)
        {
            if (item.Entry == LovelyCharmID && item.StackCount >= 10)
            {
                if (Me.BagsFull)
                {
                    PluginLog("Bugs are full! Stop.");
                    BotStop();
                    return;
                }
                if (!isCastingSend)
                {
                    item.UseContainerItem();
                    isCastingSend = true; 
                }
                return;
            }
        }

        PluginLog("Nothing to do. Stop.");
        BotStop();
    }

}

